Index: other-projects/the-macronizer/trunk/src/java/util/MacroniserLogFileProcessor.java
===================================================================
--- other-projects/the-macronizer/trunk/src/java/util/MacroniserLogFileProcessor.java	(revision 32747)
+++ other-projects/the-macronizer/trunk/src/java/util/MacroniserLogFileProcessor.java	(revision 32749)
@@ -58,4 +58,6 @@
 
             sqlAccess.makeConnection();
+
+            System.out.println("Sending " + extractedEntries.size() + " entries to DB...");
 
             //loop through all entries
Index: other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java
===================================================================
--- other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java	(revision 32747)
+++ other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java	(revision 32749)
@@ -60,5 +60,5 @@
 	private String PASSWORD; //= "pinky";
 
-	private final String PROPS_FILENAME = "mysql.properties"; // set to "properties/mysql.properties" for IntelliJ
+	private final String PROPS_FILENAME = "classes/mysql.properties"; // set to "classes/mysql.properties" for IntelliJ
 
 	//Makes a connection to the server
Index: other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.txt
===================================================================
--- other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.txt	(revision 32747)
+++ other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.txt	(revision 32749)
@@ -23,4 +23,6 @@
 
 #* 0 * * * /PATH/TO/macronLogToDB.bash > /dev/null
+
+## Stdout goes to the .out file and stderr will go to an .err file
 * 0 * * * /PATH/TO/macronLogToDB.bash > /PATH/TO/macronLogToDB.out
 
Index: other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash
===================================================================
--- other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash	(revision 32747)
+++ other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash	(revision 32749)
@@ -18,5 +18,5 @@
 
 ###################################
-macronlogs_folder=/home/wjkw1/comp520/MacroniserLogs/tmp/ #/home/wjkw1/comp520/MacroniserLogs/logs #/Scratch/wjkw1/macron-restoration/web/logs
+macronlogs_folder=/home/wjkw1/comp520/MacroniserLogs/tmp #/home/wjkw1/comp520/MacroniserLogs/logs #/Scratch/wjkw1/macron-restoration/web/logs
 #macronLogToDBjar=
 exec_folder=/home/wjkw1/IdeaProjects/LogFileExtraction/out/production/LogFileExtraction
@@ -26,7 +26,9 @@
 email_address=wilsonw9378@gmail.com #tetaka1@gmail.com
 jars_folder=/Scratch/wjkw1/mysql-connector-java-8.0.14 #/Scratch/wjkw1/macron-restoration/web/WEB-INF/lib
-mysqlprops_folder=/Scratch/wjkw1/properties #/Scratch/wjkw1/macron-restoration/web/WEB-INF/classes
+mysqlprops_folder=/Scratch/wjkw1/classes #/Scratch/wjkw1/macron-restoration/web/WEB-INF/classes
 
-echo "HELLO WORLD"
+echo ""
+echo "In script $0 to process macron.log.* files"
+echo "  Note that any logfile named exactly 'macron.log' (instead of matching macron.log.*) will not be processed"
 
 # get rid of any old error files
@@ -43,5 +45,5 @@
 mkdir -p $reprocess_folder
 
-pushd $macronlogs_folder > /dev/null
+
 # "Bash does carry out filename expansion [1] -- a process known as globbing"
 # https://www.tldp.org/LDP/abs/html/globbingref.html
@@ -50,16 +52,16 @@
 #  Correct glob use:
 #  Always use for-loop, prefix glob, check if exists file.
-for logfile in ./macron.log.* ; do         # Use ./* ... NEVER bare *
-  if [ -e "$logfile" ] ; then   # Check whether file exists.
-      echo "****** $0 script processing $logfile"      
+for logfile in $macronlogs_folder/macron.log.* ; do         # Use ./* ... NEVER bare * [EDIT: if in current folder?]
+    if [ -e "$logfile" ] ; then   # Check whether file exists.
+      echo "****** processing $logfile"      
 
       # https://askubuntu.com/questions/625224/how-to-redirect-stderr-to-a-file
 
-      # this works: java -cp /Scratch/wjkw1/mysql-connector-java-8.0.14/mysql-connector-java-8.0.14.jar:/Scratch/wjkw1/properties/mysql.properties:. util.MacroniserLogFileProcessor /home/wjkw1/comp520/MacroniserLogs/tmp/macron.log
-      #java -cp $jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder:. util.MacroniserLogFileProcessor $logfile > /dev/null 2>> $errfile
-
-      echo "java -cp $exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder:. util.MacroniserLogFileProcessor $logfile > /dev/null 2>> $errfile"
-      java -cp $exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder:. util.MacroniserLogFileProcessor $logfile      
-     
+      echo "Running command:"
+      echo "   java -cp .:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder util.MacroniserLogFileProcessor $logfile 2>> $errfile"
+      echo ""
+      java -cp .:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder util.MacroniserLogFileProcessor $logfile 2>> $errfile
+      
+      
       # The above returns 0 on success, -1 on failure
       # if 0, then move $logfile to processed_folder
@@ -82,11 +84,12 @@
 #  Correct glob use:
 #  Always use for-loop, prefix glob, check if exists file.
-for file in ./macron.log.* ; do         # Use ./* ... NEVER bare *
-  if [ -e "$file" ] ; then   # Check whether file exists.
-     echo "$file"
-  fi
-done
+#for file in ./macron.log.* ; do         # Use ./* ... NEVER bare *
+#  if [ -e "$file" ] ; then   # Check whether file exists.
+#     echo "$file"
+#  fi
+#done
 
-echo "GOODBYE"
+echo "Finished processing macron.log.* files"
+echo ""
 
 # If error file exists and has non-zero size, send email
@@ -102,5 +105,4 @@
 fi
 
-popd
 
 # Cronjob: https://stackoverflow.com/questions/8938120/how-to-run-cron-once-daily-at-10pm