Index: other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java
===================================================================
--- other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java	(revision 32753)
+++ other-projects/the-macronizer/trunk/src/java/util/MySQLAccess.java	(revision 32755)
@@ -60,5 +60,5 @@
 	private String PASSWORD; //= "pinky";
 
-	private final String PROPS_FILENAME = "classes/mysql.properties"; // set to "classes/mysql.properties" for IntelliJ
+	private final String PROPS_FILENAME = "mysql.properties"; // set to "classes/mysql.properties" for IntelliJ
 
 	//Makes a connection to the server
Index: other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.in
===================================================================
--- other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.in	(revision 32753)
+++ other-projects/the-macronizer/trunk/src/scripts-and-sql/cron.in	(revision 32755)
@@ -22,4 +22,5 @@
 # m h  dom mon dow   command
 
+## Cronjob: https://stackoverflow.com/questions/8938120/how-to-run-cron-once-daily-at-10pm
 ## Send to /dev/null if you want anything in stdout to disappear
 ## (stderr will go to a daily file called macronLogToDB.err)
Index: other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash.in
===================================================================
--- other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash.in	(revision 32753)
+++ other-projects/the-macronizer/trunk/src/scripts-and-sql/macronLogToDB.bash.in	(revision 32755)
@@ -6,8 +6,7 @@
 # Set email_address only if you have permissions to run the mail client
 # on your linux box
-email_address=wilsonw9378@gmail.com #tetaka1@gmail.com
+email_address=TYPE_NOTIFICATION_EMAIL
 
 
-#macronLogToDBjar=
 exec_folder=@logfileproc.exec_folder@ #macronizer/web/classes (containing util.MacroniserLogFileProcessor)
 macronlogs_folder=@macronizer.logs@ #macronizer/web/logs
@@ -16,5 +15,5 @@
 errfile=@logfileproc.dir@/macronLogToDB.err #/macronizer/logproc/macronLogToDB.err
 jars_folder=@jarlibs.folder@ #macronizer/web/WEB-INF/lib
-mysqlprops_folder=@classes.folder@ #/macronizer/web/WEB-INF/classes
+mysqlprops_folder=@mysqlprops.dir@ #why doesn't @logfileproc.dir@ or /macronizer/web/WEB-INF/classes work? and only the basedir of the Macronizer?
 
 echo ""
@@ -38,4 +37,5 @@
 # "Bash does carry out filename expansion [1] -- a process known as globbing"
 # https://www.tldp.org/LDP/abs/html/globbingref.html
+# May be important: https://unix.stackexchange.com/questions/264926/is-it-a-sane-approach-to-back-up-the-ifs-variable
 IFS="$(printf '\n\t')"   # Remove space.
 
@@ -49,8 +49,7 @@
 
       echo "Running command:"
-      echo "   java -cp .:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder util.MacroniserLogFileProcessor $logfile 2>> $errfile"
+      echo "   java -cp \".:$mysqlprops_folder:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder\" util.MacroniserLogFileProcessor $logfile"
       echo ""
-      java -cp .:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar:$mysqlprops_folder util.MacroniserLogFileProcessor $logfile 2>> $errfile
-      
+      java -cp ".:$mysqlprops_folder:$exec_folder:$jars_folder/mysql-connector-java-8.0.14.jar" util.MacroniserLogFileProcessor $logfile
       
       # The above returns 0 on success, -1 on failure
@@ -70,36 +69,25 @@
 done
 
-IFS="$(printf '\n\t')"   # Remove space.
-
-#  Correct glob use:
-#  Always use for-loop, prefix glob, check if exists file.
-#for file in ./macron.log.* ; do         # Use ./* ... NEVER bare *
-#  if [ -e "$file" ] ; then   # Check whether file exists.
-#     echo "$file"
-#  fi
-#done
-
 echo "Finished processing macron.log.* files in $macronlogs_folder"
 echo ""
 
-# if email address provided, attempt to send email
-#if [[ -z "${//$email_address }" ]]; then
-
-# If error file exists and has non-zero size, send email
-# https://stackoverflow.com/questions/30080997/if-file-is-exists-and-is-not-empty-always-gives-me-the-false-value
-
-if [ -s $errfile ] ; then    
-    # send email with contents of error file
-    echo "cat $errfile | mail -s 'Macron.log to DB cron failure output' $email_address"
-    # TODO: uncomment on a machine that's allowed to email
-    #cat $errfile | mail -s 'Macron.log to DB cron failure output' $email_address       
+# if email address provided, attempt to send email there
+if [ "$email_address" != "TYPE_NOTIFICATION_EMAIL" ]; then
     
-    echo "Supposed to have sent MAIL by now to $email_address"
+    # If error file exists and has non-zero size, send email
+    # https://stackoverflow.com/questions/30080997/if-file-is-exists-and-is-not-empty-always-gives-me-the-false-value
+    
+    if [ -s $errfile ] ; then    
+	# send email with contents of error file
+	echo "cat $errfile | mail -s 'Macron.log to DB cron failure output' $email_address"
+	# TODO: uncomment on a machine that's allowed to email
+	cat $errfile | mail -s 'Macron.log to DB cron failure output' $email_address       
+	
+	echo "Supposed to have sent MAIL by now to $email_address"
+    fi
 fi
-#fi
 
 
-# Cronjob: https://stackoverflow.com/questions/8938120/how-to-run-cron-once-daily-at-10pm
 
-# In an x-term, on a machine:
-# 
+
+