Index: main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl
===================================================================
--- main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl	(revision 32763)
+++ main/trunk/greenstone3/web/interfaces/default/transform/pages/document.xsl	(revision 32764)
@@ -231,4 +231,55 @@
 					</xsl:for-each>
 				</table>
+				<div id="map-and-controls-{@nodeID}">
+					<div id="map-{@nodeID}" style="height: 300px;"><xsl:text> </xsl:text></div>
+					
+
+					<div id="ControlPanel-{@nodeID}" class="ControlPanel">
+						<div id="ControlButtons">
+							<script>
+							   //var myMapEditor = MapEditor('{@nodeID}');
+							</script>
+							<button onclick="deleteAllShape('{@nodeID}')" accesskey="c">Clear All</button>
+							<button onclick="deleteSelectedShape('{@nodeID}')" accesskey="b">Delete Selected</button>
+							<button onclick="undo('{@nodeID}')" accesskey="n">Undo</button>
+<!--							<button onclick="myMapEditor.getHistory().undo('{@nodeID}')" accesskey="n">Undo</button> -->
+							<button onclick="redo('{@nodeID}')" accesskey="n">Redo</button>
+							<input type="checkbox" name="draggableCB" id="draggableCB-{@nodeID}" value="false" /> Lock all shapes location <br/>
+						</div>
+						
+						<div id="SecondRow">
+							<div id="LineThickness">
+								<p>Line thickness: <input type="range" min="20" max="100" value="1" class="slider" id="thicknessRange-{@nodeID}" /> </p>
+								<p>Value: <span id="thicknessRangeVal-{@nodeID}"></span></p>
+							</div>	
+							
+							<div id="ColourOpacity">
+								<p>Colour opacity: <input type="range" min="10" max="100" value="40" class="slider" id="colourOpacity-{@nodeID}" /> </p>
+								<p>Value: <span id="opacityRangeVal-{@nodeID}"></span></p>
+							</div>
+						</div>
+						<div id = "ThirdRow">
+							<div id="FillColour">
+								<p> Fill Colour:</p> <div id="color-palette1-{@nodeID}"><xsl:text> </xsl:text></div> 
+							</div>
+						</div>
+					</div>
+				-
+					<div id="style-selector-control-{@nodeID}"  class="map-control">
+					  <select id="style-selector-{@nodeID}" class="selector-control">
+						<option value="default" selected="selected">Default</option>
+						<option value="silver">Silver</option>
+						<option value="night">Night mode</option>
+						<option value="retro">Retro</option>
+						<option value="paleDawn">Pale Dawn</option>
+						<option value="avocadoWorld">Avocado World</option>
+						<option value="bright">Bright</option>
+						<option value="turquoise">Turquoise</option>
+						<option value="hiding">Hide features</option>
+					  </select>
+					</div>		
+				
+				</div>
+				
 				<xsl:call-template name="sectionContentForEditing"/>
 			</xsl:when>
@@ -275,5 +326,11 @@
 			<script type="text/javascript" src="interfaces/{$interface_name}/js/documentedit_scripts.js"><xsl:text> </xsl:text></script>
 			<script type="text/javascript" src="interfaces/{$interface_name}/js/documentedit_scripts_util.js"><xsl:text> </xsl:text></script>
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/map-scripts-editor-history.js"><xsl:text> </xsl:text></script>
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/map-scripts-editor-themes.js"><xsl:text> </xsl:text></script>		
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/map-scripts-editor.js"><xsl:text> </xsl:text></script>		
 			<script type="text/javascript" src="interfaces/{$interface_name}/js/hierarchy.js"><xsl:text> </xsl:text></script>
+			
+			<link rel="stylesheet" href="interfaces/{$interface_name}/style/map-editors.css" type="text/css"/>
+			
 			<script type="text/javascript">
 				<xsl:text disable-output-escaping="yes">
@@ -294,5 +351,5 @@
                                         <xsl:text disable-output-escaping="yes">','</xsl:text><xsl:value-of select="@metadata"/><xsl:text disable-output-escaping="yes">');</xsl:text>
                                 </xsl:for-each>
-                                <xsl:text disable-output-escaping="yes">});</xsl:text>
+                                <xsl:text disable-output-escng="yes">});</xsl:text>
 
 			</script>