Index: main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm	(revision 32782)
+++ main/trunk/greenstone2/perllib/plugins/GreenstoneSQLPlugin.pm	(revision 32783)
@@ -74,7 +74,7 @@
 my $rollback_on_cancel_list =
     [ { 'name' => "true",
-        'desc' => "{GreenstoneSQLPlug.rollback_on_cancel}" },      
+        'desc' => "{common.true}" },      
       { 'name' => "false",
-        'desc' => "{GreenstoneSQLPlug.rollbacl_on_cancel}" } ];
+        'desc' => "{common.false}" } ];
 
 # NOTE: If subclassing gsmysql for other supporting databases and if they have different required
Index: main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm	(revision 32782)
+++ main/trunk/greenstone2/perllib/plugins/HathiTrustMETSPlugin.pm	(revision 32783)
@@ -94,10 +94,4 @@
 	'type' => "flag",
 	'reqd' => "no" },
-#      { 'name' => "documenttype",
-#	'desc' => "{HathiTrustMETSPlugin.documenttype}",
-#	'type' => "enum",
-#	'list' => $type_list,
-#	'deft' => "auto",
-#	'reqd' => "no" },
       {'name' => "processing_tmp_files",
        'desc' => "{BaseImporter.processing_tmp_files}",
@@ -107,7 +101,7 @@
 
 my $doc_type_opt = { 'name' => "documenttype",
-		     'desc' => "{HathiTrustMETSPlugin.documenttype}",
+		     'desc' => "{PagedImagePlugin.documenttype}",
 		     'type' => "enum",
-		     'deft' => "auto",
+		     'deft' => "hierarchy",
 		     'reqd' => "no" };
 
Index: main/trunk/greenstone2/perllib/plugins/ImageConverter.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 32782)
+++ main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 32783)
@@ -116,8 +116,8 @@
 	'desc' => "{ImageConverter.aspectpad_mode}",
 	'type' => "enum",
-	'list' => [{'name' => "al", 'desc' => "{aspectpad.al}"},
-		   {'name' => "ap", 'desc' => "{aspectpad.ap}"},
-		   {'name' => "l",  'desc' => "{aspectpad.l}"},
-		   {'name' => "p",  'desc' => "{aspectpad.p}"}],
+	'list' => [{'name' => "al", 'desc' => "{ImageConverter.aspectpad_mode.al}"},
+		   {'name' => "ap", 'desc' => "{ImageConverter.aspectpad_mode.ap}"},
+		   {'name' => "l",  'desc' => "{ImageConverter.aspectpad_mode.l}"},
+		   {'name' => "p",  'desc' => "{ImageConverter.aspectpad_mode.p}"}],
 	'deft' => "al",
 	'reqd' => "no" },
Index: main/trunk/greenstone2/perllib/plugins/PDFv1Plugin.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugins/PDFv1Plugin.pm	(revision 32782)
+++ main/trunk/greenstone2/perllib/plugins/PDFv1Plugin.pm	(revision 32783)
@@ -93,5 +93,5 @@
        'type' => "flag" },
      { 'name' => "zoom",
-       'desc' => "{PDFv1Plugin.zoom}",
+       'desc' => "{PDFPlugin.zoom}",
        'deft' => "2",
        'range' => "1,3", # actually the range is 0.5-3 
Index: main/trunk/greenstone2/perllib/strings.properties
===================================================================
--- main/trunk/greenstone2/perllib/strings.properties	(revision 32782)
+++ main/trunk/greenstone2/perllib/strings.properties	(revision 32783)
@@ -939,4 +939,9 @@
 GISExtractor.place_list:When extracting placements, include list of placenames at start of the document. Requires GIS extension to Greenstone.
 
+HathiTrustMETSPlugin.desc:Plugin that processes HathiTrust METS files which are accompanied by page-by-page OCR'd text files (in a subfolder with the same name as the METS file).
+
+HathiTrustMETSPlugin.headerpage:Add a top level header page (containing dunny text) to each document.
+
+
 HBPlugin.desc:Plugin which processes an HTML book directory. This plugin is used by the Humanity Development Library collections and does not handle input encodings other than ASCII or extended ASCII. This code is not very clean and could no doubt be made to run faster, by leaving it in this state we hope to encourage the utilisation of BookPlugin instead ;-)\n\nUse BookPlugin if creating a new collection and marking up files like the Humanity Library collections. BookPlugin accepts all input encodings but expects the marked up files to be cleaner than those used by the Humanity Library collections
 
@@ -1022,4 +1027,13 @@
 BaseMediaConverter.enable_cache:Cache automatically generated files (such as thumbnails and screen-size images) so they don't need to be repeatedly generated.
 
+ImageConverter.apply_aspectpad: Pad images with a colour to a specified aspect ratio and orientation
+ImageConverter.aspectpad_colour: The desired padding colour.
+ImageConverter.aspectpad_mode: Padding mode
+ImageConverter.aspectpad_mode.al: Preserve the aspect orientation of the original image, but pad a square image to landscape format.
+ImageConverter.aspectpad_mode.ap: Preserve the aspect orientation of the original image, but pad a square image to portrait format.
+ImageConverter.aspectpad_mode.l: Force the result orientation to be landscape.
+ImageConverter.aspectpad_mode.p: Force the result orientation to be portrait.
+ImageConverter.aspectpad_ratio: The desired aspect ratio. 
+ImageConverter.aspectpad_tolerance: Aspect tolerance. If the difference between existing and desired aspect is less than tolerance, no padding will be applied.
 ImageConverter.converttotype:Convert main image to format 's'.
 
@@ -1040,4 +1054,6 @@
 
 ImageConverter.screenviewtype:Make screenview images in format 's'.
+
+ImageConverter.store_original_image: Save the original image as an associated file. Only useful if -converttotype is used, as otherwise the original image is already stored. 
 
 ImageConverter.thumbnailsize:Make thumbnails of size nxn.
@@ -1204,5 +1220,5 @@
 PDFv1Plugin.win_old_pdftotext_unsupported:*** On Windows, PDFv1Plugin does not support pdf to text. PDFs will be converted to HTML instead.\n*** Use PDFv2Plugin if you want pdf to actual text conversion.
 
-PDFv1Plugin.zoom:The factor by which to zoom the PDF for output. Only useful if -complex is set.
+PDFPlugin.zoom:The factor by which to zoom the PDF for output. Only useful if -complex is set.
 
 PDFv2Plugin.dpi:The resolution in DPI of background images generated when convert_to is set to any of the pagedimg(txt) and (paged_)pretty_html formats.
@@ -1303,4 +1319,6 @@
 
 StructuredHTMLPlugin.toc_header:possible user-defined header styles for the table of contents, table of figures etc, to be removed if delete_toc is set.
+
+TabSeparatedPlugin.desc: A plugin for tab-separated metadata files.
 
 TextPlugin.desc:Creates simple single-level document. Adds Title metadata of first line of text (up to 100 characters long).